function [Corected_code] = BCH127_8_CORECTIN_CODE_BOB(code,syndromeA,m,t,n,polygen) 
% m=7;
% n=2^m-1;
% t=31;
k=2^m-1-m*t;
simplified = 1;


% Parameters of GF(p^m)
% BCH code parameters
% log(initial zero)
% -----------------------------------------------------------------------
%               Generate the Galois field, GF(2^m)
% -----------------------------------------------------------------------
% Primitive polynomial: x^4 + x + 1
% pol=gfprimdf(m);
% for i=1:length(pol)
% if pol(i)==1
% f(i)=1;
% else
% f(i)=0;
% end
% end
% pold=bi2de(f);



%the constants used in the algorithm
alpha = gf(2,m,polygen);
zero = gf(0, m,polygen);
one = gf(1, m,polygen);

%since all zero is always a codeword, only have to specify the error

reccodeB = gf(code,m,polygen);


%creating alpha array
%note that syndrome should be in the order [s3, s2, s1, s0]
alpha_tb=gf(zeros(1, 2*t), m,polygen);
for i=1:2*t
    alpha_tb(i)=alpha^(2*t-i+1);
end

%syndrome generation

syndromeB=gf(zeros(1, 2*t), m,polygen);
for i=1:n
    syndromeB=syndromeB.*alpha_tb+reccodeB(i);
end

syndrome=syndromeA-syndromeB;


%imba
lambda = gf([1, zeros(1, t)], m,polygen);
lambda0= lambda;
b=gf([0, 1, zeros(1, t)], m,polygen);
b2 = gf([0, 0, 1, zeros(1, t)], m,polygen);
k=0;
gamma = one;
delta = zero;
syndrome_array = gf(zeros(1, t+1), m,polygen);

if(simplified == 1) 
    for r=1:t
        r1 = 2*t-2*r+2;
        r2 = min(r1+t, 2*t);
        num = r2-r1+1;
        syndrome_array(1: num) = syndrome(r1:r2);
        delta = syndrome_array*lambda';
        
        lambda0 = lambda;
        lambda = gamma*lambda-delta*b2(2:t+2);
        
        if((delta~= zero) && (k>=0))
            b2(3)=zero;
            b2(4:3+t) = lambda0(1:t);
            gamma = delta;
            k = -k;
        else
            b2(3:3+t) = b2(1:t+1);
            gamma = gamma;
            k=k+2;
        end
        joke=1;
    end
else
    for r=1:2*t
        r1 = 2*t-r+1;
        r2 = min(r1+t, 2*t);
        num = r2-r1+1;
        syndrome_array(1:num) = syndrome(r1:r2);
        delta = syndrome_array*lambda';

        lambda0 = lambda;
        lambda = gamma*lambda-delta*b(1:t+1);

        if((delta ~= zero) && (k>=0))
            b(2:2+t)=lambda0;
            gamma = delta;
            k=-k-1;
        else
            b(2:2+t) = b(1:t+1);
            gamma = gamma;
            k=k+1;
        end   
        joke=1;
    end
end

%inverstable
inverse_tb = gf(zeros(1, t+1), m,polygen);
for i=1:t+1
    inverse_tb(i) = alpha^(-i+1);
end

%chien's search
lambda_v = zero;
accu_tb=gf(ones(1, t+1), m,polygen);
for i=1:n
    lambda_v=lambda*accu_tb';
    accu_tb = accu_tb.*inverse_tb;
    if(lambda_v==zero)
        error(1,n-i+1)=1;
    else
        error(1,n-i+1)=0;
    end
end

found = find(error(1,:)~=0);
    
Corected_code=mod((code+error),2);

% if Corected_code==codewordA
%     'corect'
% else
%     'INcorect'
% end
% % error
% %    syndrome 
%     
%     Ham_distance=pdist2((codewordA),(Corected_code),'hamming')*length(codewordA)
%     
%     
%     